package com.tzld.piaoquan.wecom.service.Impl;

import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.wecom.service.AccessTokenService;
import com.tzld.piaoquan.wecom.utils.HttpClientUtil;
import com.tzld.piaoquan.wecom.utils.HttpPoolClient;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.concurrent.TimeUnit;

@Service
public class AccessTokenServiceImpl implements AccessTokenService {

    private static final HttpPoolClient httpPoolClientDefault = HttpClientUtil.create(30000, 30000, 2000, 5000, 5, 30000);

    private String POST_ACCESS_TOKEN_URL = "https://open.weibanzhushou.com/open-api/access_token/get";
    private String ACCESS_TOKEN = "ACCESS_TOKEN";

    private String CROP_ID = "1804267877438678017";

    private String SECRET = "9fe05442559750d0cc3e71c5f81217a4";

    @Autowired
    private RedisTemplate<String, String> redisTemplate;

    @Override
    public String getAccessToken() {
        String accessToken = redisTemplate.opsForValue().get(ACCESS_TOKEN);
        if (StringUtils.isNotEmpty(accessToken)) {
            return accessToken;
        }
        JSONObject param = new JSONObject();
        param.put("corp_id", CROP_ID);
        param.put("secret", SECRET);
        try {
            String res = httpPoolClientDefault.postJson(POST_ACCESS_TOKEN_URL, param.toJSONString());
            JSONObject jsonObject = JSONObject.parseObject(res);
            Long expiresIn = jsonObject.getLong("expires_in");
            String newAccessToken = jsonObject.getString("access_token");
            redisTemplate.opsForValue().set(ACCESS_TOKEN, newAccessToken, expiresIn, TimeUnit.SECONDS);
            return newAccessToken;
        } catch (IOException e) {
            //TODO 打印错误日志
            e.printStackTrace();
        }
        return null;
    }
}
